    001/* ========================================================================
    002 * JCommon : a free general purpose class library for the Java(tm) platform
    003 * ========================================================================
    004 *
    005 * (C) Copyright 2000-2005, by Object Refinery Limited and Contributors.
    006 *
    007 * Project Info:  http://www.jfree.org/jcommon/index.html
    008 *
    009 * This library is free software; you can redistribute it and/or modify it
    010 * under the terms of the GNU Lesser General Public License as published by
    011 * the Free Software Foundation; either version 2.1 of the License, or
    012 * (at your option) any later version.
    013 *
    014 * This library is distributed in the hope that it will be useful, but
    015 * WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY
    016 * or FITNESS FOR A PARTICULAR PURPOSE. See the GNU Lesser General Public
    017 * License for more details.
    018 *
    019 * You should have received a copy of the GNU Lesser General Public
    020 * License along with this library; if not, write to the Free Software
    021 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301,
    022 * USA.
    023 *
    024 * [Java is a trademark or registered trademark of Sun Microsystems, Inc.
    025 * in the United States and other countries.]
    026 *
    027 * --------------------------
    028 * LongObjectDescription.java
    029 * --------------------------
    030 * (C)opyright 2003, 2004, by Thomas Morgner and Contributors.
    031 *
    032 * Original Author:  Thomas Morgner;
    033 * Contributor(s):   David Gilbert (for Object Refinery Limited);
    034 *
    035 * $Id: SimpleDateFormatObjectDescription.java,v 1.3 2005/11/14 11:04:12 mungady Exp $
    036 *
    037 * Changes (from 19-Feb-2003)
    038 * -------------------------
    039 * 19-Feb-2003 : Added standard header and Javadocs (DG);
    040 * 29-Apr-2003 : Distilled from the JFreeReport project and moved into JCommon
    041 *
    042 */
    043
    044package org.jfree.xml.factory.objects;
    045
    046import java.text.DateFormatSymbols;
    047import java.text.NumberFormat;
    048import java.text.SimpleDateFormat;
    049import java.util.Calendar;
    050import java.util.Date;
    051
    052/**
    053 * An object-description for a <code>SimpleDateFormat</code> object.
    054 *
    055 * @author Thomas Morgner
    056 */
    057public class SimpleDateFormatObjectDescription extends BeanObjectDescription {
    058
    059    /**
    060     * Creates a new object description.
    061     */
    062    public SimpleDateFormatObjectDescription() {
    063        this(SimpleDateFormat.class);
    064    }
    065
    066    /**
    067     * Creates a new object description.
    068     *
    069     * @param className  the class.
    070     */
    071    public SimpleDateFormatObjectDescription(final Class className) {
    072        this(className, true);
    073    }
    074
    075    /**
    076     * Creates a new object description.
    077     *
    078     * @param className  the class.
    079     * @param init  initialise?
    080     */
    081    public SimpleDateFormatObjectDescription(final Class className, final boolean init) {
    082        super(className, false);
    083        setParameterDefinition("2DigitYearStart", Date.class);
    084        setParameterDefinition("calendar", Calendar.class);
    085        setParameterDefinition("dateFormatSymbols", DateFormatSymbols.class);
    086        setParameterDefinition("lenient", Boolean.TYPE);
    087        setParameterDefinition("numberFormat", NumberFormat.class);
    088//        setParameterDefinition("timeZone", TimeZone.class);
    089        setParameterDefinition("localizedPattern", String.class);
    090        setParameterDefinition("pattern", String.class);
    091        ignoreParameter("localizedPattern");
    092        ignoreParameter("pattern");
    093    }
    094
    095    /**
    096     * Sets the parameters of this description object to match the supplied object.
    097     *
    098     * @param o  the object.
    099     *
    100     * @throws ObjectFactoryException if there is a problem while reading the
    101     * properties of the given object.
    102     */
    103    public void setParameterFromObject(final Object o)
    104        throws ObjectFactoryException {
    105        super.setParameterFromObject(o);
    106        final SimpleDateFormat format = (SimpleDateFormat) o;
    107        setParameter("localizedPattern", format.toLocalizedPattern());
    108        setParameter("pattern", format.toPattern());
    109    }
    110
    111    /**
    112     * Creates an object based on this description.
    113     *
    114     * @return The object.
    115     */
    116    public Object createObject() {
    117        final SimpleDateFormat format = (SimpleDateFormat) super.createObject();
    118        if (getParameter("pattern") != null) {
    119            format.applyPattern((String) getParameter("pattern"));
    120        }
    121        if (getParameter("localizedPattern") != null) {
    122            format.applyLocalizedPattern((String) getParameter("localizedPattern"));
    123        }
    124        return format;
    125    }
    126
    127}